<?php
/**************************************************
  Coppermine 1.5.x Plugin - short_comments
  *************************************************
  Copyright (c) 2011 Pierre BASMOREAU
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  ********************************************
  $HeadURL: 
  $Revision: 1.1
  $LastChangedBy: 
  $Date: 2011/08/25 - 2011/10/23
  **************************************************/
 
if (!defined('IN_COPPERMINE')) { 
    die('Not in Coppermine...');
}
if (!defined('PLUGINMGR_PHP')) {
	define('PLUGINMGR_PHP', true);
}
if (!defined('ADMIN_PHP')) {
    define('ADMIN_PHP', true);
}
if (!defined('CORE_PLUGIN')) {
    define('CORE_PLUGIN', true);
}

// Add plugin_cleanup action
$thisplugin->add_action('plugin_cleanup','short_comments_cleanup');
// Add plugin_uninstall action
$thisplugin->add_action('plugin_uninstall','short_comments_uninstall');
// Add plugin_install action
$thisplugin->add_action('plugin_install','short_comments_install');
// Add filter to display comments
$thisplugin->add_filter('theme_display_thumbnails_params','short_comments');
// Add filter for page head
$thisplugin->add_filter('page_meta','short_comments_head');


/********************************************************************
Insert style
********************************************************************/
function short_comments_head($meta)
{
	$meta  .= <<< EOT
	<!-- BEGIN style for short_comments -->
    <link rel="stylesheet" href="plugins/short_comments/style.css" type="text/css" />
	<!-- END style for short_comments -->
EOT;
	return $meta;
}

/********************************************************************
Makes short comment if needed

<span class="thumb_title">Tietgenkollegiet</span>
<span class="thumb_title">vu 2 fois</span>
<span class="thumb_caption">L&#039;architecture de ce btiment rond offrant 400 logements tudiants, est inspir des constructions Tulou du Sud-Est de la Chine.<br />
Inaugur en 2006.<br />
Architectes : Lundgaard &amp; Tranberg Architects</span>
<span class="thumb_caption">14 Aot 2011</span>

<span class="thumb_title">Maria de Faykod</span>
<span class="thumb_title">vu 26 fois</span>
<span class="thumb_caption">L&#39;artiste ralise actuellement une srie de 17 sculptures monumentales reprsentants les 17 stations du Chemin de Croix du Christ destines au Sanctuaire Notre-Dame de Lourdes.<br />
L&#39;inauguration est prvue en 2008  l&#39;occasion du 150me anniversaire des Apparitions de la Sainte Vierge  Bernadette Soubirous.<br />
Tous les dtails de cette oeuvre monumentale sont sur ce site<br /></span>
<span class="thumb_caption"><img src="themes/timoswelt/images/rate_full.png" alt="5"/><img src="themes/timoswelt/images/rate_full.png" alt="5"/><img src="themes/timoswelt/images/rate_full.png" alt="5"/><img src="themes/timoswelt/images/rate_full.png" alt="5"/><img src="themes/timoswelt/images/rate_full.png" alt="5"/><br />(2 votes)</span>

<span class="thumb_title">Monastre de Gronimo</span>
<span class="thumb_title">vu 19 fois</span>
<span class="thumb_caption">Le monastre de Gronimo (Mosteiro dos Jeronimos), bti en 1502, tait destin aux hironymites, moines de l&#039;ordre de Saint-Jrme.<br />
Il symbolise l&#039;art manulin, transformation de l&#039;art gothique, surtout dans l&#039;ornementation.<br />
Le monastre est class au Patrimoine Mondial de l&#039;Unesco.</span>

<span class="thumb_title">Tietgenkollegiet</span>
<span class="thumb_title">vu 2 fois</span>
<span class="thumb_caption">L&#039;architecture de ce btiment rond offrant 400 logements tudiants, est inspir des constructions Tulou du Sud-Est de la Chine.<br />
Inaugur en 2006.<br />
Architectes : Lundgaard &amp; Tranberg Architects</span>
<span class="thumb_caption">14 Aot 2011</span>

<span class="thumb_title">Arcades du Parc du Cinquantenaire (Bruxelles)</span>
<span class="thumb_title">vu 0 fois</span>
********************************************************************/
function short_comments($params)
{
	GLOBAL $lang_plugin_short_comments, $CONFIG, $row;
	require ('./plugins/short_comments/include/init.inc.php');

	$maxwords = $CONFIG['plugin_short_comments_maxwords'];
	// Extract comments for each picture
	$caption_text = $params['{CAPTION}'];

	// First occurence (updated 06/09/2011)
	$p1 = stripos($caption_text, "<span class=\"thumb_caption\">");
	if ($p1 == true) {
		$end_comment = '';
		//First occurence of <span>
		$p2 = stripos($caption_text, "</span>", $p1 + strlen("<span class=\"thumb_caption\">"));

		// End comment for album = topn / toprated / lastup / (added 06/09/2011)
		$p3 = strrpos($caption_text, "<span class=\"thumb_caption\">");
		if ($p3 > $p1) {
			$end_comment = substr($caption_text, $p3);
		}
		
		//Comment between 2 occurences
		$comment = substr($caption_text, $p1 + strlen("<span class=\"thumb_caption\">"), $p2-$p1);
		$comment = htmlspecialchars_decode(strip_tags($comment)); // Remove some keywords HTML like < /br>
		// Array of words
		$words = explode(" ", $comment);	// explode works well with UTF-8 (not use str_word_count)
		// New array with only maxwords
		$newwords = array_slice($words, 0, $maxwords);
		$nbwords = count($newwords);
		if ($nbwords == $maxwords) {
			//Link to view picture and entire comment
			$msg_suite = '<span class="thumb_caption_suite">' . '<a href=' . $params['{LINK_TGT}'] . '>' .$lang_plugin_short_comments['more'] . '</a>...</span>';
			$comment = implode(" ",$newwords);
			// Build new comment with short comment + end_comment if needed
			$comment = "<span class=\"thumb_caption\">" . $comment . $msg_suite . '</span>' . $end_comment;
			$params['{CAPTION}'] = substr($caption_text, 0, $p1) . $comment ;
		}
	}
	return $params;
}

/********************************************************************
Uninstall plugin
********************************************************************/
function short_comments_uninstall()
{
	global $CONFIG;
	$short_comments_superCage = Inspekt::makeSuperCage();

	if (!$short_comments_superCage->post->keyExists('drop')) {
		return 1;
	}
	// Drop the infos configuration
	if ($short_comments_superCage->post->getInt('drop') == 1) {
		cpg_db_query("DELETE FROM {$CONFIG['TABLE_PREFIX']}config WHERE name LIKE 'plugin_short_comments_%'");
	}
	return true;
}

/********************************************************************
Ask if we want to drop the table
********************************************************************/
function short_comments_cleanup($action) {

    global $lang_plugin_geodata, $CONFIG;
	require_once('./plugins/short_comments/include/init.inc.php');

    $short_comments_superCage = Inspekt::makeSuperCage();
    $cleanup = $short_comments_superCage->server->getEscaped('REQUEST_URI');

    if ($action===1) {
    echo <<< EOT
    <form action="{$cleanup}" method="post">
        <table border="0" cellspacing="0" cellpadding="0">
            <tr>
                <td class="tableb">
                    {$lang_plugin_short_comments['short_comments_remove']}
                </td>
                <td class="tableb">
                    <input type="radio" name="drop" id="drop_yes" value="1" />
                    <label for="drop_yes" class="clickable_option">{$lang_plugin_short_comments['yes']}</label>
                </td>
                <td class="tableb">
                    <input type="radio" name="drop" id="drop_no" checked="checked" value="0" />
                    <label for="drop_no" class="clickable_option">{$lang_plugin_short_comments['no']}</label>
                </td>
                <td class="tableb">
                    <input type="submit" name="submit" value="{$lang_plugin_short_comments['submit_button']}">
                </td>
            </tr>
        </table>
    </form>
EOT;
    }
}

/********************************************************************
Install plugin
********************************************************************/
function short_comments_install()
{
	global $CONFIG, $thisplugin;
	
	//Create fields in TABLE_CONFIG if not exists
	if (!$CONFIG['plugin_short_comments_nwords']) {
		$sql = "INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} values ('plugin_short_comments_maxwords','20')";
		cpg_db_query($sql);
	}
	return true;
}
?>